CNN_MODEL_PARAMS = {'conv': [{'filters': 64, 'kernel_size': (3, 3), 'padding': 'same',
                              'max_pool_after': False,
                              'batch_norm_after': False},
                             {'filters': 64, 'kernel_size': (3, 3), 'padding': 'same',
                              'max_pool_after': True,
                              'max_pool_size': (2, 2),
                              'max_pool_padding': 'valid',
                              'batch_norm_after': False},
                             {'filters': 64, 'kernel_size': (3, 3), 'padding': 'same',
                              'max_pool_after': True,
                              'max_pool_size': (2, 2),
                              'max_pool_padding': 'valid',
                              'batch_norm_after': False}],
                    'dense': [{'units': 128,
                               'batch_norm_after': False}]}

# https://github.com/geifmany/cifar-vgg/blob/master/cifar10vgg.py
CNN_VGG_MODEL_PARAMS = {'conv': [{'filters': 64, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.3},
                                 {'filters': 64, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': True, 'max_pool_padding': 'valid', 'max_pool_size': (2, 2),
                                  'batch_norm_after': True,
                                  'dropout_after': False},
                                 {'filters': 128, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 128, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': True, 'max_pool_padding': 'valid', 'max_pool_size': (2, 2),
                                  'batch_norm_after': True,
                                  'dropout_after': False},
                                 {'filters': 256, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 256, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 256, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': True, 'max_pool_padding': 'valid', 'max_pool_size': (2, 2),
                                  'batch_norm_after': True,
                                  'dropout_after': False},
                                 {'filters': 512, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 512, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 512, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': True, 'max_pool_padding': 'valid', 'max_pool_size': (2, 2),
                                  'batch_norm_after': True,
                                  'dropout_after': False},
                                 {'filters': 512, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 512, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': False,
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.4},
                                 {'filters': 512, 'kernel_size': (3, 3), 'padding': 'same',
                                  'max_pool_after': True, 'max_pool_padding': 'valid', 'max_pool_size': (2, 2),
                                  'batch_norm_after': True,
                                  'dropout_after': True, 'dropout_rate': 0.5}
                                 ],
                        'dense': [{'units': 512,
                                   'batch_norm_after': True,
                                   'dropout_after': True, 'dropout_rate': 0.5},
                                  {'units': 512,
                                   'batch_norm_after': False,
                                   'dropout_after': False, 'dropout_rate': 0.0}
                                  ]}

